From 5f1ef9eb8825b724e67258ce87839a9fe11b64dc Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 9 Dec 2022 19:24:05 +0100
Subject: [PATCH 4/4] toulouse-maelis: use responses in tests (#72205)

---
 tests/data/toulouse_maelis/Q_create_child.xml |  25 -
 .../toulouse_maelis/Q_create_child_person.xml |  56 --
 .../data/toulouse_maelis/Q_create_family.xml  |  59 --
 .../data/toulouse_maelis/Q_create_person.xml  |  44 -
 tests/data/toulouse_maelis/Q_create_rl1.xml   |  31 -
 tests/data/toulouse_maelis/Q_create_rl2.xml   |  35 -
 .../Q_create_update_quotient.xml              |  23 -
 .../toulouse_maelis/Q_delete_child_person.xml |  20 -
 .../data/toulouse_maelis/Q_delete_person.xml  |  21 -
 tests/data/toulouse_maelis/Q_update_child.xml |  50 --
 .../Q_update_child_dietcode.xml               |  16 -
 .../Q_update_child_indicator.xml              |  24 -
 .../Q_update_child_medical_record.xml         |  44 -
 .../toulouse_maelis/Q_update_child_pai.xml    |  18 -
 .../toulouse_maelis/Q_update_child_person.xml |  36 -
 .../toulouse_maelis/Q_update_coordinate.xml   |  42 -
 .../data/toulouse_maelis/Q_update_family.xml  |  80 --
 .../data/toulouse_maelis/Q_update_person.xml  |  33 -
 tests/data/toulouse_maelis/Q_update_rl1.xml   |  35 -
 tests/data/toulouse_maelis/Q_update_rl2.xml   |  35 -
 .../toulouse_maelis/Q_update_rl_indicator.xml |  24 -
 tests/test_toulouse_maelis.py                 | 754 ++++++++----------
 tests/utils.py                                |  20 +-
 23 files changed, 338 insertions(+), 1187 deletions(-)
 delete mode 100644 tests/data/toulouse_maelis/Q_create_child.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_child_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_family.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_rl1.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_rl2.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_create_update_quotient.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_delete_child_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_delete_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child_dietcode.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child_indicator.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child_medical_record.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child_pai.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_child_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_coordinate.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_family.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_person.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_rl1.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_rl2.xml
 delete mode 100644 tests/data/toulouse_maelis/Q_update_rl_indicator.xml

diff --git a/tests/test_toulouse_maelis.py b/tests/test_toulouse_maelis.py
index 04b9742f..0f5ef10c 100644
--- a/tests/test_toulouse_maelis.py
+++ b/tests/test_toulouse_maelis.py
@@ -14,18 +14,18 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 import logging
 import os
 from unittest import mock
 
 import pytest
 import responses
-from lxml import etree
 from requests.exceptions import ConnectionError
+from zeep import Settings
 
 from passerelle.contrib.toulouse_maelis.models import Link, Referential, ToulouseMaelis
 from passerelle.utils.jsonresponse import APIError
 from passerelle.utils.soap import SOAPError
 from tests.utils import FakedResponse, ResponsesSoap, generic_endpoint_url, setup_access_rights
 
 TEST_BASE_DIR = os.path.join(os.path.dirname(__file__), 'data', 'toulouse_maelis')
 
@@ -37,93 +37,102 @@ def get_xml_file(filename):
 
 CONNECTION_ERROR = ConnectionError('No address associated with hostname')
 FAMILY_SERVICE_WSDL = FakedResponse(content=get_xml_file('FamilyService.wsdl'), status_code=200)
 ACTIVITY_SERVICE_WSDL = FakedResponse(content=get_xml_file('ActivityService.wsdl'), status_code=200)
 INVOICE_SERVICE_WSDL = FakedResponse(content=get_xml_file('InvoiceService.wsdl'), status_code=200)
 FAILED_AUTH = FakedResponse(content=get_xml_file('R_failed_authentication.xml'), status_code=500)
 ISWSRUNNING_TRUE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'true', status_code=200)
 ISWSRUNNING_FALSE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'false', status_code=200)
-READ_FAMILY = FakedResponse(content=get_xml_file('R_read_family.xml'), status_code=200)
-READ_FAMILY_LAX = FakedResponse(content=get_xml_file('R_read_family_relax.xml'), status_code=200)
-READ_FAMILY_ORD = FakedResponse(content=get_xml_file('R_read_family_reordered.xml'), status_code=200)
-READ_FAMILY_QUOTIENT = FakedResponse(
-    content=get_xml_file('R_read_family_with_income_year.xml'), status_code=200
-)
-READ_RL1_FAMILY = FakedResponse(content=get_xml_file('R_read_family_with_only_rl1.xml'), status_code=200)
-IS_RL_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'true', status_code=200)
-IS_RL_EXISTS_FALSE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'false', status_code=200)
-IS_CHILD_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_child_exists.xml') % b'true', status_code=200)
-IS_CHILD_EXISTS_FALSE = FakedResponse(
-    content=get_xml_file('R_is_child_exists.xml') % b'false', status_code=200
-)
-CREATE_FAMILY = FakedResponse(content=get_xml_file('R_create_family.xml'), status_code=200)
-CREATE_FAMILY_ERR = FakedResponse(content=get_xml_file('R_create_family_error.xml'), status_code=200)
-CREATE_CHILD = FakedResponse(content=get_xml_file('R_create_child.xml'), status_code=200)
-CREATE_CHILD_ERR = FakedResponse(content=get_xml_file('R_create_child_error.xml'), status_code=200)
-UPDATE_FAMILY = FakedResponse(content=get_xml_file('R_update_family.xml'), status_code=200)
-UPDATE_FAMILY_ERR = FakedResponse(content=get_xml_file('R_update_family_error.xml'), status_code=200)
-UPDATE_FAMILY_500 = FakedResponse(content=get_xml_file('R_update_family_soap_error.xml'), status_code=500)
-UPDATE_QUOTIENT = FakedResponse(content=get_xml_file('R_create_update_quotient.xml'), status_code=200)
-UPDATE_QUOTIENT_500 = FakedResponse(
-    content=get_xml_file('R_create_update_quotient_soap_error.xml'), status_code=500
-)
-UPDATE_DIETCODE = FakedResponse(content=get_xml_file('R_update_child_dietcode.xml'), status_code=200)
-UPDATE_PAI = FakedResponse(content=get_xml_file('R_update_child_pai.xml'), status_code=200)
-UPDATE_PAI_500 = FakedResponse(content=get_xml_file('R_update_child_pai_soap_error.xml'), status_code=500)
-UPDATE_MEDICAL = FakedResponse(content=get_xml_file('R_update_child_medical_record.xml'), status_code=200)
-UPDATE_MEDICAL_500 = FakedResponse(
-    content=get_xml_file('R_update_child_medical_record_soap_error.xml'), status_code=500
-)
-UPDATE_CHILD_AUTO = FakedResponse(content=get_xml_file('R_update_child_authorization.xml'), status_code=200)
-UPDATE_INDICATOR = FakedResponse(content=get_xml_file('R_update_indicator.xml'), status_code=200)
-
-
-def assert_sent_payload(mocked_post, query_file):
-    soap_sent = etree.tostring(etree.fromstring(mocked_post.call_args.kwargs['data']), pretty_print=True)
-    expected = etree.tostring(etree.fromstring(get_xml_file(query_file)), pretty_print=True)
-    assert soap_sent.decode() == expected.decode()
 
 
 def get_endpoint(name):
     url = generic_endpoint_url('toulouse-maelis', name)
     assert url == '/toulouse-maelis/test/%s' % name
     return url
 
 
+@pytest.fixture()
+def family_service():
+    with ResponsesSoap(
+        wsdl_url='https://example.org/FamilyService?wsdl',
+        wsdl_content=get_xml_file('FamilyService.wsdl'),
+        settings=Settings(strict=False, xsd_ignore_sequence_order=True),
+    )() as mock:
+        yield mock
+
+
+@pytest.fixture()
+def activity_service():
+    with ResponsesSoap(
+        wsdl_url='https://example.org/ActivityService?wsdl',
+        wsdl_content=get_xml_file('ActivityService.wsdl'),
+        settings=Settings(strict=False, xsd_ignore_sequence_order=True),
+    )() as mock:
+        yield mock
+
+
+@pytest.fixture()
+def invoice_service():
+    with ResponsesSoap(
+        wsdl_url='https://example.org/InvoiceService?wsdl',
+        wsdl_content=get_xml_file('InvoiceService.wsdl'),
+        settings=Settings(strict=False, xsd_ignore_sequence_order=True),
+    )() as mock:
+        yield mock
+
+
 @pytest.fixture(scope='module')
 def django_db_setup(django_db_setup, django_db_blocker):
     with django_db_blocker.unblock():
         con = setup_access_rights(
             ToulouseMaelis.objects.get_or_create(
                 slug='test',
+                base_wsdl_url='https://example.org/',
                 zeep_wsse_username='maelis-webservice',
                 zeep_wsse_password='maelis-password',
             )[0]
         )
-        with mock.patch('passerelle.utils.Request.get') as mocked_get:
-            mocked_get.return_value = FAMILY_SERVICE_WSDL
-            with mock.patch('passerelle.utils.Request.post') as mocked_post:
-                mocked_post.side_effect = [
-                    FakedResponse(content=get_xml_file('R_read_category_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_child_indicator_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_civility_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_country_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_csp_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_dietcode_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_organ_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_pai_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_quality_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_quotient_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_rl_indicator_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_situation_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_street_list.xml'), status_code=200),
-                    FakedResponse(content=get_xml_file('R_read_vaccin_list.xml'), status_code=200),
-                ]
-                con.daily()
+
+        with responses.RequestsMock() as mock:
+            family_service = ResponsesSoap(
+                wsdl_url='https://example.org/FamilyService?wsdl',
+                wsdl_content=get_xml_file('FamilyService.wsdl'),
+                settings=Settings(strict=False, xsd_ignore_sequence_order=True),
+            )
+            mock.add(responses.GET, family_service.wsdl_url, body=family_service.wsdl_content, status=200)
+            family_service.add_soap_response(
+                mock, 'readCategoryList', get_xml_file('R_read_category_list.xml')
+            )
+            family_service.add_soap_response(
+                mock, 'readChildIndicatorList', get_xml_file('R_read_child_indicator_list.xml')
+            )
+            family_service.add_soap_response(
+                mock, 'readCivilityList', get_xml_file('R_read_civility_list.xml')
+            )
+            family_service.add_soap_response(mock, 'readCountryList', get_xml_file('R_read_country_list.xml'))
+            family_service.add_soap_response(mock, 'readCSPList', get_xml_file('R_read_csp_list.xml'))
+            family_service.add_soap_response(
+                mock, 'readDietCodeList', get_xml_file('R_read_dietcode_list.xml')
+            )
+            family_service.add_soap_response(mock, 'readOrganList', get_xml_file('R_read_organ_list.xml'))
+            family_service.add_soap_response(mock, 'readPAIList', get_xml_file('R_read_pai_list.xml'))
+            family_service.add_soap_response(mock, 'readQualityList', get_xml_file('R_read_quality_list.xml'))
+            family_service.add_soap_response(
+                mock, 'readQuotientList', get_xml_file('R_read_quotient_list.xml')
+            )
+            family_service.add_soap_response(
+                mock, 'readRLIndicatorList', get_xml_file('R_read_rl_indicator_list.xml')
+            )
+            family_service.add_soap_response(
+                mock, 'readSituationList', get_xml_file('R_read_situation_list.xml')
+            )
+            family_service.add_soap_response(mock, 'readStreetList', get_xml_file('R_read_street_list.xml'))
+            family_service.add_soap_response(mock, 'readVaccinList', get_xml_file('R_read_vaccin_list.xml'))
+            con.daily()
 
     # reset change in zeep private interface to bypass clear_cache fixture
     from zeep.cache import InMemoryCache
 
     InMemoryCache._cache = {}
 
 
 @pytest.fixture()
@@ -136,42 +145,36 @@ def test_call_with_wrong_wsdl_url(mocked_get, con):
     mocked_get.side_effect = CONNECTION_ERROR
     with pytest.raises(
         SOAPError,
         match='cannot be loaded: No address associated with hostname',
     ) as e:
         con.call('Family', 'isWSRunning')
     assert e.value.err == 1
     assert e.value.http_status == 200
-    assert e.value.url == 'https://demo-toulouse.sigec.fr/maelisws-toulouse/services/FamilyService?wsdl'
+    assert e.value.url == 'https://example.org/FamilyService?wsdl'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_call_with_wrong_credentials(mocked_post, mocked_get, con):
-    mocked_get.side_effect = [FAMILY_SERVICE_WSDL]
-    mocked_post.side_effect = [FAILED_AUTH]
+def test_call_with_wrong_credentials(family_service, con):
+    family_service.add_soap_response('isWSRunning', get_xml_file('R_failed_authentication.xml'), status=500)
     with pytest.raises(
         APIError,
         match='The security token could not be authenticated or authorized',
     ) as e:
         con.call('Family', 'isWSRunning')
     assert e.value.__dict__ == {
         'err': 1,
         'log_error': False,
         'http_status': 200,
         'err_code': 'Family-isWSRunning-ns1:FailedAuthentication',
     }
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_call(mocked_post, mocked_get, con):
-    mocked_get.side_effect = [FAMILY_SERVICE_WSDL]
-    mocked_post.side_effect = [ISWSRUNNING_TRUE]
+def test_call(family_service, con):
+    family_service.add_soap_response('isWSRunning', get_xml_file('R_is_ws_running.xml') % b'true')
     resp = con.call('Family', 'isWSRunning')
     assert resp is True
 
 
 @pytest.mark.parametrize(
     'get_responses, post_responses, exception',
     [
         (
@@ -290,66 +293,54 @@ def test_cron(db):
         'Sex',
         'Situation',
         'Street',
         'Vaccin',
     ]
     assert Referential.objects.count() == 230
 
 
-@pytest.fixture
-def family_service():
-    from zeep import Settings
-
-    with ResponsesSoap(
-        wsdl_url='https://demo-toulouse.sigec.fr/maelisws-toulouse/services/FamilyService?wsdl',
-        wsdl_content=get_xml_file('FamilyService.wsdl'),
-        settings=Settings(strict=False, xsd_ignore_sequence_order=True),
-    )() as mock:
-        yield mock
-
-
 def test_link(family_service, con, app):
     def request_check(request):
-        assert request.dossierNumber == 1313
+        assert request.dossierNumber == 1312
 
     family_service.add_soap_response(
         'readFamily', get_xml_file('R_read_family.xml'), request_check=request_check
     )
     url = get_endpoint('link')
     assert Link.objects.count() == 0
 
     params = {
         'family_id': '1312',
         'firstname': 'Jhon',
         'lastname': 'Doe',
         'dateBirth': '1938-07-26',
     }
-    resp = app.post_json(url + '?NameID=local&raise=1', params=params)
+    resp = app.post_json(url + '?NameID=local', params=params)
     assert Link.objects.count() == 1
     assert resp.json['err'] == 0
     assert resp.json['data'] == 'ok'
 
     params['lastname'] = 'John'
     resp = app.post_json(url + '?NameID=local', params=params)
     assert Link.objects.count() == 1
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "RL1 does not match '1312' family"
 
 
 def test_link_additional_properties_error(con, app):
     url = get_endpoint('link')
-
     params = {
         'family_id': '1312',
         'firstname': 'Jhon',
         'lastname': 'Doe',
         'dateBirth': '1938-07-26',
         'plop': 42,
     }
+
     resp = app.post_json(url + '?NameID=local', params=params, status=400)
     assert resp.json['err'] == 1
     assert resp.json['err_desc'] == "Additional properties are not allowed ('plop' was unexpected)"
 
 
 def test_unlink(con, app):
     url = get_endpoint('unlink')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
@@ -381,29 +372,27 @@ def test_get_referential_value_not_found(con, caplog):
     assert con.get_referential_value('Civility', 'MR') == 'MR'
     assert len(caplog.records) == 1
     assert caplog.records[0].levelno == logging.WARNING
     assert caplog.records[0].message == "No 'MR' key into Maelis 'Civility' referential"
 
 
 def test_read_category_list(con, app):
     url = get_endpoint('read-category-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
         {'id': 'BI', 'text': 'BIPARENTALE', 'code': 'BI', 'libelle': 'BIPARENTALE'},
         {'id': 'ACCEUI', 'text': "FAMILLE D'ACCUEIL", 'code': 'ACCEUI', 'libelle': "FAMILLE D'ACCUEIL"},
         {'id': 'MONO', 'text': 'MONOPARENTALE', 'code': 'MONO', 'libelle': 'MONOPARENTALE'},
     ]
 
 
 def test_read_country_list(con, app):
     url = get_endpoint('read-country-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 3
     assert resp.json['data'] == [
         {'id': '212', 'code': '212', 'text': 'AFGHANISTAN', 'libelle': 'AFGHANISTAN'},
         {'id': '303', 'code': '303', 'text': 'AFRIQUE DU SUD', 'libelle': 'AFRIQUE DU SUD'},
         {'id': '125', 'code': '125', 'text': 'ALBANIE', 'libelle': 'ALBANIE'},
     ]
@@ -581,17 +570,16 @@ def test_read_rl_indicator_list(con, app):
             'label': 'Etablissement spécialisé',
             'typeDesc': 'NOTE',
         },
     ]
 
 
 def test_read_sex_list(con, app):
     url = get_endpoint('read-sex-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
         {'id': 'F', 'text': 'Féminin'},
         {'id': 'M', 'text': 'Masculin'},
     ]
 
 
@@ -673,22 +661,21 @@ def test_read_vaccin_list(con, app):
             'id': 'DTC',
             'code': 'DTC',
             'text': 'DIPHTERIE TETANOS COQUELUCHE',
             'libelle': 'DIPHTERIE TETANOS COQUELUCHE',
         },
     ]
 
 
-@pytest.mark.parametrize("read_family", [READ_FAMILY, READ_FAMILY_LAX, READ_FAMILY_ORD])
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_family(mocked_post, mocked_get, read_family, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = read_family
+@pytest.mark.parametrize(
+    "xml", ['R_read_family.xml', 'R_read_family_relax.xml', 'R_read_family_reordered.xml']
+)
+def test_read_family(family_service, xml, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file(xml))
     url = get_endpoint('read-family')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local')
     assert resp.json['err'] == 0
     data = resp.json['data']
     del data['RL1']
     del data['RL2']
@@ -805,17 +792,17 @@ def test_read_family(mocked_post, mocked_get, read_family, con, app):
         'bLeaveAlone': False,
         'insurance': None,
         'subscribeSchoolList': [],
         'mother': {'num': 613963, 'civility': 'MME', 'firstname': 'JANE', 'lastname': 'DOE'},
         'father': {'num': 613878, 'civility': 'M.', 'firstname': 'JHON', 'lastname': 'DOE'},
         'rl': None,
         'subscribeActivityList': [],
     }
-    if read_family != READ_FAMILY_LAX:
+    if xml != 'R_read_family_relax.xml':
         assert resp.json['data']['childList'][0]['paiInfoBean'] == {
             'code': 'PAIALI',
             'code_text': 'ALIMENTAIRE',
             'dateDeb': '2022-01-01T00:00:00+01:00',
             'dateFin': '2022-12-31T00:00:00+01:00',
             'description': 'bla bla PAI',
         }
     else:
@@ -902,34 +889,28 @@ def test_read_family(mocked_post, mocked_get, read_family, con, app):
 def test_read_family_not_linked_error(con, app):
     url = get_endpoint('read-family')
 
     resp = app.get(url + '?NameID=')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_rl1(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_rl1(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=613878')
     assert resp.json['err'] == 0
     assert resp.json['data']['firstname'] == 'JHON'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_rl1_with_income_year(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY_QUOTIENT
+def test_read_rl1_with_income_year(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family_with_income_year.xml'))
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=613878&income_year=2020')
     assert resp.json['err'] == 0
     assert resp.json['data']['quotientList'] == [
         {
             'yearRev': 2020,
@@ -938,21 +919,18 @@ def test_read_rl1_with_income_year(mocked_post, mocked_get, con, app):
             'mtt': 1500.33,
             'cdquo': 'QS',
             'cdquo_text': 'QUOTIENT SCOLAIRE',
             'codeUti': None,
         }
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_rl2(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_rl2(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=613879')
     assert resp.json['err'] == 0
     assert resp.json['data'] == {
         'num': '613879',
         'lastname': 'DOE',
@@ -1007,210 +985,170 @@ def test_read_rl2(mocked_post, mocked_get, con, app):
 def test_read_rl_not_linked_error(con, app):
     url = get_endpoint('read-rl')
 
     resp = app.get(url + '?NameID=local&rl_id=613879')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_rl_not_found(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_rl_not_found(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=000000')
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "no '000000' RL on '1312' family"
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_person(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_person(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-person')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&person_id=614059')
     assert resp.json['err'] == 0
     assert resp.json['data']['firstname'] == 'KENY'
 
 
 def test_read_person_not_linked_error(con, app):
     url = get_endpoint('read-person')
 
     resp = app.get(url + '?NameID=local&person_id=614059')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_person_not_found(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_person_not_found(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-person')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&person_id=000000')
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "no '000000' emergency person on '1312' family"
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_child(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-child')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&child_id=613880')
     assert resp.json['err'] == 0
     assert resp.json['data']['firstname'] == 'JANNIS'
 
 
 def test_read_child_not_linked_error(con, app):
     url = get_endpoint('read-child')
 
     resp = app.get(url + '?NameID=local&child_id=613880')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child_not_found(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_child_not_found(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-child')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&child_id=000000')
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "no '000000' child on '1312' family"
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child_person(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_child_person(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-child-person')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&child_id=613880&person_id=614719')
     assert resp.json['err'] == 0
     assert resp.json['data']['personInfo']['firstname'] == 'AMEL'
 
 
 def test_read_child_person_not_linked_error(con, app):
     url = get_endpoint('read-child-person')
 
     resp = app.get(url + '?NameID=local&child_id=613880&person_id=614719')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child_person_no_child_error(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_child_person_no_child_error(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-child-person')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&child_id=42&person_id=614719')
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "no '42' child on '1312' family"
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child_person_no_person_error(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_FAMILY
+def test_read_child_person_no_person_error(family_service, con, app):
+    family_service.add_soap_response('readFamily', get_xml_file('R_read_family.xml'))
     url = get_endpoint('read-child-person')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&child_id=613880&person_id=000000')
     assert resp.json['err'] == 'not-found'
     assert resp.json['err_desc'] == "no '000000' authorized person on '613880' child"
 
 
-@pytest.mark.parametrize(
-    'post_response, result',
-    [
-        (IS_RL_EXISTS_TRUE, True),
-        (IS_RL_EXISTS_FALSE, False),
-    ],
-)
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_is_rl_exists(mocked_post, mocked_get, post_response, result, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = post_response
+@pytest.mark.parametrize('string, result', [(b'true', True), (b'false', False)])
+def test_is_rl_exists(string, result, family_service, con, app):
+    family_service.add_soap_response('isRLExists', get_xml_file('R_is_rl_exists.xml') % string)
     url = get_endpoint('is-rl-exists')
-
     params = {
         'firstname': 'Jhon',
         'lastname': 'Doe',
         'dateBirth': '1938-07-26',
     }
+
     resp = app.post_json(url, params=params)
     assert resp.json['err'] == 0
     assert resp.json['data'] == result
 
 
 def test_is_rl_exists_schema_error(con, app):
     url = get_endpoint('is-rl-exists')
-
     params = {
         'firstname': 'Jhon',
         'lastname': 'Doe',
         'dateBirth': '1938-07-26 more text',
     }
+
     resp = app.post_json(url, params=params, status=400)
     assert resp.json['err'] == 1
     assert "does not match '^[0-9]{4}-[0-9]{2}-[0-9]{2}$'" in resp.json['err_desc']
 
 
-@pytest.mark.parametrize(
-    'post_response, result',
-    [
-        (IS_CHILD_EXISTS_TRUE, True),
-        (IS_CHILD_EXISTS_FALSE, False),
-    ],
-)
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_is_child_exists(mocked_post, mocked_get, post_response, result, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = post_response
+@pytest.mark.parametrize('string, result', [(b'true', True), (b'false', False)])
+def test_is_child_exists(family_service, string, result, con, app):
+    family_service.add_soap_response('isChildExists', get_xml_file('R_is_rl_exists.xml') % string)
     url = get_endpoint('is-child-exists')
-
     params = {
         'firstname': 'Doe',
         'lastname': 'Jhonny allen',
         'dateBirth': '1942-11-27',
     }
+
     resp = app.post_json(url, params=params)
     assert resp.json['err'] == 0
     assert resp.json['data'] == result
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_create_family(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = CREATE_FAMILY
+def test_create_family(family_service, con, app):
+    def request_check(request):
+        assert request.emergencyPersonList[0]['firstname'] == 'Keny'
+
+    family_service.add_soap_response(
+        'createFamily', get_xml_file('R_create_family.xml'), request_check=request_check
+    )
     url = get_endpoint('create-family')
     params = {
         'category': 'ACCEUI',
         'situation': 'C',
         'rl1/civility': 'M.',
         'rl1/firstname': 'Jhon',
         'rl1/lastname': 'Doe',
         'rl1/quality': 'AU',
